/*
        del_stat.c - statistical udf for InterBase or FireBird
        Idea:
        CreateHandle
        AddData
        Compute
        FreeHandle

        Copyright (C) 2002  Slavomir Skopalik

        This library is free software; you can redistribute it and/or
        modify it under the terms of the GNU Library General Public
        License as published by the Free Software Foundation; either
        version 2 of the License, or (at your option) any later version.

        This library is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
        Library General Public License for more details.

        You should have received a copy of the GNU Library General Public
        License along with this library; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

e-mail:skopalik@hlubocky.del.cz
http://hlubocky.del.cz/udf

*/

DECLARE EXTERNAL FUNCTION StatInit
        RETURNS Integer BY VALUE
        ENTRY_POINT 'StatInit' MODULE_NAME 'del_stat';

DECLARE EXTERNAL FUNCTION StatFree
        INTEGER
        RETURNS Integer BY VALUE
        ENTRY_POINT 'StatFree' MODULE_NAME 'del_stat';

DECLARE EXTERNAL FUNCTION StatClear
        INTEGER
        RETURNS Integer BY VALUE
        ENTRY_POINT 'StatClear' MODULE_NAME 'del_stat';

DECLARE EXTERNAL FUNCTION StatDuplicate
        INTEGER
        RETURNS Integer BY VALUE
        ENTRY_POINT 'StatDuplicate' MODULE_NAME 'del_stat';

DECLARE EXTERNAL FUNCTION StatCount
        INTEGER
        RETURNS Integer BY VALUE
        ENTRY_POINT 'StatCount' MODULE_NAME 'del_stat';

DECLARE EXTERNAL FUNCTION StatAdd
  Integer,
  Double Precision
  RETURNS INTEGER BY VALUE
        ENTRY_POINT 'StatAdd' MODULE_NAME 'del_stat';

DECLARE EXTERNAL FUNCTION StatAddTimeStamp
  Integer,
  TimeStamp
  RETURNS INTEGER BY VALUE
        ENTRY_POINT 'StatAddTimeStamp' MODULE_NAME 'del_stat';

DECLARE EXTERNAL FUNCTION StatGetItem
  Integer,
  Integer
  RETURNS Double Precision BY VALUE
        ENTRY_POINT 'StatGetItem' MODULE_NAME 'del_stat';

DECLARE EXTERNAL FUNCTION StatGetItemTimeStamp
  Integer,
  Integer
  RETURNS TimeStamp FREE_IT
        ENTRY_POINT 'StatGetItemTimeStamp' MODULE_NAME 'del_stat';

DECLARE EXTERNAL FUNCTION StatCentralMoment
  Integer,
  Integer
  RETURNS Double Precision BY VALUE
        ENTRY_POINT 'StatCentralMoment' MODULE_NAME 'del_stat';

DECLARE EXTERNAL FUNCTION StatCommonMoment
  Integer,
  Integer
  RETURNS Double Precision BY VALUE
        ENTRY_POINT 'StatCommonMoment' MODULE_NAME 'del_stat';

DECLARE EXTERNAL FUNCTION StatMedian
  Integer
  RETURNS Double Precision BY VALUE
        ENTRY_POINT 'StatMedian' MODULE_NAME 'del_stat';

DECLARE EXTERNAL FUNCTION StatMedianTimeStamp
  Integer
  RETURNS TimeStamp FREE_IT
		ENTRY_POINT 'StatMedianTimeStamp' MODULE_NAME 'del_stat';

DECLARE EXTERNAL FUNCTION StatMean
  Integer
  RETURNS Double Precision BY VALUE
        ENTRY_POINT 'StatMean' MODULE_NAME 'del_stat';

DECLARE EXTERNAL FUNCTION StatMeanTimeStamp
  Integer
  RETURNS TimeStamp FREE_IT
        ENTRY_POINT 'StatMeanTimeStamp' MODULE_NAME 'del_stat';

DECLARE EXTERNAL FUNCTION StatMin
  Integer
  RETURNS Double Precision BY VALUE
        ENTRY_POINT 'StatMin' MODULE_NAME 'del_stat';

DECLARE EXTERNAL FUNCTION StatMax
  Integer
  RETURNS Double Precision BY VALUE
        ENTRY_POINT 'StatMax' MODULE_NAME 'del_stat';

DECLARE EXTERNAL FUNCTION StatRange
  Integer
  RETURNS Double Precision BY VALUE
        ENTRY_POINT 'StatRange' MODULE_NAME 'del_stat';

DECLARE EXTERNAL FUNCTION StatVariance
  Integer
  RETURNS Double Precision BY VALUE
        ENTRY_POINT 'StatVariance' MODULE_NAME 'del_stat';

DECLARE EXTERNAL FUNCTION StatVarianceSel
  Integer
  RETURNS Double Precision BY VALUE
        ENTRY_POINT 'StatVarianceSel' MODULE_NAME 'del_stat';

DECLARE EXTERNAL FUNCTION StatSum
  Integer
  RETURNS Double Precision BY VALUE
        ENTRY_POINT 'StatSum' MODULE_NAME 'del_stat';

DECLARE EXTERNAL FUNCTION StatStdDev
  Integer
  RETURNS Double Precision BY VALUE
        ENTRY_POINT 'StatStdDev' MODULE_NAME 'del_stat';

DECLARE EXTERNAL FUNCTION StatStdDevSel
  Integer
  RETURNS Double Precision BY VALUE
        ENTRY_POINT 'StatStdDevSel' MODULE_NAME 'del_stat';

DECLARE EXTERNAL FUNCTION StatSkew
  Integer
  RETURNS Double Precision BY VALUE
        ENTRY_POINT 'StatSkew' MODULE_NAME 'del_stat';

DECLARE EXTERNAL FUNCTION StatSkewSel
  Integer
  RETURNS Double Precision BY VALUE
        ENTRY_POINT 'StatSkewSel' MODULE_NAME 'del_stat';

/*
 Least Squadre regresion metod
 Min(Sum((A0*Xi^0 + A1*Xi^1 + ... + An*Xi^n - Yi)^2))
*/
DECLARE EXTERNAL FUNCTION StatLS
  Integer,                        /* Handle to X Values */
  Integer,                        /* Handle to Y Values */
  Integer                         /* Degree of aproximation polynom (n)*/
  RETURNS Integer BY VALUE        /* Handle to Stat Object with result values */
		ENTRY_POINT 'StatLS' MODULE_NAME 'del_stat';

/*
  Compute value of polynom by Horner optimal schema
  ((a[n]*X + a[n-1])*X + a[n-2])*X + a[n-3] ...
*/
DECLARE EXTERNAL FUNCTION StatPoly
  Integer,                        /* Handle to polynom coeficients */
  Double Precision                /* X value */
  RETURNS Double Precision BY VALUE
        ENTRY_POINT 'StatPoly' MODULE_NAME 'del_stat';


